package 
{
	import flash.display.Bitmap;
	import flash.display.DisplayObject;
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.utils.getDefinitionByName;
	import flash.display.Sprite;
	import flash.ui.Mouse;
	import flash.ui.MouseCursor;
	import source.GetURL;
	
	public class Preloader extends MovieClip 
	{
		
		private var square:Sprite = new Sprite();
		private var border:Sprite = new Sprite();
		private var size:Number = 256;
		private var borderColor:uint = 0x008800;
		private var loaderColor:uint = 0x44FF44;
		
		private var loaded:Boolean = false;
		
		[SWF(width = "640", height = "480")]
		
		
		public function Preloader() 
		{
			addEventListener(Event.ENTER_FRAME, checkFrame);
			// show loader
			addChild(square);
			square.x = (stage.stageWidth / 2) -((size-8)/2);
			square.y = stage.stageHeight *5/6;
			
			addChild(border);
			border.x = (stage.stageWidth / 2) - (size/2);
			border.y = stage.stageHeight *5/6 - 4;
	
		}
		
		public function checkDomain(allowed:*):Boolean
		{
			var url:String = root.stage.loaderInfo.url;
			var startCheck:int = url.indexOf('://' ) + 3;
			if (url.substr(0, startCheck) == 'file://') return true;
	
			var domainLen:int = url.indexOf('/', startCheck) - startCheck;
			var host:String = url.substr(startCheck, domainLen);
	
			if (allowed is String) allowed = [allowed];
			for each (var d:String in allowed)
			{
				if (host.substr(-d.length, d.length) == d) return true;
			}
	
			return false;
		}
				private function checkFrame(e:Event):void 
		{
			if (true)//!loaded)
			{
				if (currentFrame == totalFrames) 
				{
					removeEventListener(Event.ENTER_FRAME, checkFrame);
					startup();
				}
				var cval:Number = loaderInfo.bytesLoaded / loaderInfo.bytesTotal;
				square.graphics.beginFill(loaderColor);
				square.graphics.drawRect(0,0, cval * (size-8),20);
				square.graphics.endFill();
				
				border.graphics.clear();
				border.graphics.lineStyle(2, borderColor);
				border.graphics.drawRect(0, 0, size, 28);
			}
		}
		
		private function startup():void 
		{
			// hide loader
			//loaded = true;
			stop();
			Mouse.cursor = MouseCursor.ARROW;
			
			//remove all the children
			var i:int = numChildren;
			while (i --) removeChildAt(i)
			
			//go to the main class
			var mainClass:Class = getDefinitionByName("Main") as Class;
			addChild(new mainClass as DisplayObject);
		}
		
	}
	
}