package  
{
	import flash.display.DisplayObject;
	import flash.geom.Point;
	import flash.ui.Mouse;
	import flash.ui.MouseCursor;
	import source.Menu;
	import net.flashpunk.FP;
	import net.flashpunk.World;
	import net.flashpunk.utils.Input;
	import source.GetURL;
	/**
	 * ...
	 * @author Time
	 */
	public class Splash extends World
	{
		[Embed(source = 'assets/graphics/OctoLogo.png')] public static var imgOctoLogo:Class;
		public static var sp:DisplayObject = new imgOctoLogo();
		
		private var timerSplash:int = 150;
		private var timerAll:int = timerSplash;
		
		private var prevColor:uint = 0;
		
		public var percentageFinished:Number = 1 - timerSplash / timerAll;
		
		public function Splash()
		{
			prevColor = FP.screen.color;
			FP.screen.color = 0x000000;
		}
		override public function begin():void
		{
			FP.engine.addChild(sp);
			sp.x = 0;
			sp.y = 0;
		}
		override public function end():void
		{
			FP.screen.color = prevColor;
			FP.engine.removeChild(sp);
		}
		override public function update():void
		{
			super.update();
			percentageFinished = 1 - timerAll / timerSplash;
			if (percentageFinished <= 0.25)
			{
				sp.alpha = percentageFinished * 4;
			}
			else if (percentageFinished < 0.75)
			{
				sp.alpha = 1;
			}
			else
			{
				sp.alpha = 1 - (percentageFinished - 0.75) * 4;
			}
			if (timerAll <= 0)
			{
				startMenu();
				return;
			}
			else
			{
				timerAll--;
			}
			if (inBounds())
			{
				Mouse.cursor = MouseCursor.BUTTON;
				if (Input.mouseReleased)
				{
					new GetURL("http://www.connorullmann.com/");
				}
			}
			else
			{
				Mouse.cursor = MouseCursor.ARROW;
			}
		}
		public function startMenu():void
		{
			if (checkDomain(["connorullmann.com"]))
			{
				Mouse.cursor = MouseCursor.ARROW;
				FP.world = new Menu();
			}
		}
		public function inBounds():Boolean
		{
			return FP.engine.mouseX >= Splash.sp.x && FP.engine.mouseY >= Splash.sp.y && FP.engine.mouseX <= Splash.sp.x + Splash.sp.width && FP.engine.mouseY <= Splash.sp.y + Splash.sp.height;
		}
		public function checkDomain (allowed:*):Boolean
		{
			var url:String = FP.stage.loaderInfo.url;
			var startCheck:int = url.indexOf('://' ) + 3;
			
			if (url.substr(0, startCheck) == 'file://') return true;
			
			var domainLen:int = url.indexOf('/', startCheck) - startCheck;
			var host:String = url.substr(startCheck, domainLen);
			
			if (allowed is String) allowed = [allowed];
			for each (var d:String in allowed)
			{
				if (host.substr(-d.length, d.length) == d) return true;
			}
			
			return false;
		}
		
	}

}