package source 
{
	import flash.geom.Point;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.Sfx;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.World;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.utils.Draw;
	/*
	 * The main menu of the game. We use this to load a new game, continue an old one,
	 * or to check out the options
	 */
	public class Menu extends World
	{
		[Embed(source = "../assets/sounds/CaveMenu.mp3")] private static var sndCaveMenu:Class;
		private var sndOCaveMenu:Sfx = new Sfx(sndCaveMenu);
		
		[Embed(source = "../assets/graphics/sunset.png")] private var imgSunset:Class;
		private var sprSunset:Spritemap;
		
		private var sunsetPos:Point;
		
		private var change:Boolean;
		private var cover:Number;
		private const coverRate:Number = 0.025;
		
		private var text:Text;
		
		public function Menu() 
		{
			sprSunset = new Spritemap(imgSunset, 320, 240)
			sunsetPos = new Point(FP.screen.width / 2, -FP.screen.height);
			sprSunset.originX = 160;
			sprSunset.originY = 0;
			sprSunset.x = -sprSunset.originX;
			sprSunset.y = -sprSunset.originY;
			
			change = false;
			cover = 1;
			
			Text.size = 16;
			text = new Text("Arrow keys + X + C");
			text.color = 0xFFFFFF;
		}
		
		override public function begin():void
		{
			sndOCaveMenu.loop();
		}
		
		override public function end():void
		{
			sndOCaveMenu.stop();
		}
		
		override public function update():void
		{
			FP.camera = new Point(0,0);
			
			if (cover > 0 && !change)
			{
				cover -= coverRate;
			}
			else if (cover < 1 && change)
			{
				cover += coverRate;
				sunsetPos.y += ( -FP.screen.height * 2 - sunsetPos.y) / 50;
				sndOCaveMenu.volume = 1 - cover;
			}
			else if (cover >= 1 && change)
			{
				FP.world = new Game();
			}
			sunsetPos.y += -sunsetPos.y / 50;
			sunsetPos.y = Math.min(FP.screen.height, sunsetPos.y);
			if ( Input.pressed( Global.keyA ) || Input.pressed(Global.keyDown) || Input.pressed(Global.keyUp) || Input.pressed(Global.keyLeft) || Input.pressed(Global.keyRight) || Input.pressed(Global.keyDive) ) { 
				//fade out, go to the game
				change = true;
			}
		}
		
		override public function render():void
		{
			sprSunset.frame = 0;
			sprSunset.render(new Point(sunsetPos.x, sunsetPos.y * 0.3), new Point());
			sprSunset.frame = 1;
			sprSunset.render(new Point(sunsetPos.x, sunsetPos.y * 0.6), new Point());
			sprSunset.frame = 2;
			sprSunset.render(new Point(sunsetPos.x, sunsetPos.y), new Point());
			Draw.rect(0, sunsetPos.y + FP.screen.height, FP.screen.width, FP.screen.height, 0x000000);
			super.render();
			
			text.color = 0x444444;
			text.render(new Point(FP.screen.width - text.width - 5, FP.screen.height - text.height), new Point());
			text.render(new Point(FP.screen.width - text.width - 4, FP.screen.height - text.height - 1), new Point());
			text.render(new Point(FP.screen.width - text.width - 3, FP.screen.height - text.height), new Point());
			text.render(new Point(FP.screen.width - text.width - 4, FP.screen.height - text.height + 1), new Point());
			text.render(new Point(FP.screen.width - text.width - 5, FP.screen.height - text.height - 1), new Point());
			text.render(new Point(FP.screen.width - text.width - 3, FP.screen.height - text.height - 1), new Point());
			text.render(new Point(FP.screen.width - text.width - 3, FP.screen.height - text.height + 1), new Point());
			text.render(new Point(FP.screen.width - text.width - 5, FP.screen.height - text.height + 1), new Point());
			
			text.color = 0x8888FF;
			text.render(new Point(FP.screen.width - text.width - 4, FP.screen.height - text.height), new Point());
			
			Draw.rect(0, 0, FP.screen.width, FP.screen.height, 0x000000, cover);
		}
		
	}

}