package source.Objects 
{
	import flash.geom.Point;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.Sfx;
	/**
	 * ...
	 * @author Time
	 */
	public class Faller extends Enemy
	{
		[Embed(source = "../../assets/sounds/Faller.mp3")] private var sndFaller:Class;
		private var sndOFaller:Sfx = new Sfx(sndFaller);
		
		[Embed(source = "../../assets/graphics/faller.png")] private var imgFaller:Class;
		private var sprFaller:Spritemap = new Spritemap(imgFaller, 64, 102);
		
		private var playedSound:Boolean = false;
		private var falling:Boolean = false;
		private var go:Point = new Point();
		
		public function Faller(_x:int) 
		{
			super(_x, FP.height + sprFaller.height / 2);
			type = "Faller";
			sprFaller.add("Fall", [0, 1, 2, 1], 0.2);
			sprFaller.play("Fall");
			sprFaller.centerOO();
			setHitbox(32, 48, 16, 42);
			
			sprFaller.scaleX = 0.25;
			sprFaller.scaleY = -0.25;
			sprFaller.color = 0x888888;
			
			graphic = sprFaller;
		}
		
		override public function update():void
		{
			var player:Player = FP.world.nearestToEntity("Player", this) as Player;
			if (player)
			{
				if (falling)
				{
					gravity();
					sprFaller.scaleX = sprFaller.scaleY = 1;
					sprFaller.color = 0xFFFFFF;
				}
				else
				{
					if (player.x >= x - 96)
					{
						speed.y = -4;
					}
					
					if(speed.y == 0)
					{
						y = FP.camera.y + FP.height/2 + sprFaller.height / 2;
					}
					
					if (y <= FP.camera.y - sprFaller.height / 2)
					{
						falling = true;
						go.x = player.x + 32;
						go.y = player.y;
						x = go.x;
						speed.y = mMaxspeed.y;
					}
				}
				
				collidable = false;
				if (falling)
				{
					if (y + height / 2 >= FP.camera.y + FP.screen.height/2 && !playedSound)
					{
						sndOFaller.play();
						playedSound = true;
					}
					if (y + height/2 < go.y)
					{
						motionx(this, speed.x);
						motiony(this, speed.y);
					}
					else
					{
						collidable = true;
						motion();
					}
					
					if (y >= FP.camera.y + FP.height + sprFaller.height / 2)
					{
						FP.world.remove(this);
					}
				}
				else
				{
					motionx(this, speed.x);
					motiony(this, speed.y);
				}
			}
		}
		
	}

}