package source.Objects 
{
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.utils.Draw;
	import flash.display.BlendMode;
	import flash.geom.Point;
	import net.flashpunk.FP;
	import source.Game;
	/**
	 * ...
	 * @author Time
	 */
	public class Sitter extends Enemy
	{
		[Embed(source = "../../assets/graphics/sitter.png")] private var imgSitter:Class;
		private var sprSitter:Spritemap = new Spritemap(imgSitter, 16, 40, endAnim);
		[Embed(source = "../../assets/graphics/sitterLights.png")] private var imgSitterLights:Class;
		private var sprSitterLights:Spritemap = new Spritemap(imgSitterLights, 16, 40);
		
		private const timeMax:int = 100;
		private var time:int = 0;
		
		public function Sitter(_x:int, _y:int) 
		{
			super(_x, _y);
			graphic = sprSitter;
			
			sprSitter.centerOO();
			sprSitterLights.centerOO();
			
			sprSitter.add("Sit", [0, 1, 2, 3], 0.1);
			sprSitter.add("Hurt", [4, 0, 4, 0, 4], 0.1);
			
			sprSitter.play("Sit");
			
			type = "Sitter";
			setHitbox(16, 28, 8, 20);
		}
		
		override public function update():void
		{
			speed.y = Math.sin(time / timeMax * 2 * Math.PI);
			time = (time + 1) % timeMax;
			motion();
		}
		
		public function lightDraw():void
		{
			Draw.setTarget(Game.lights);
			sprSitterLights.angle = sprSitter.angle;
			sprSitterLights.frame = sprSitter.frame % imgSitterLights.frameCount;
			sprSitterLights.scaleX = sprSitter.scaleX;
			sprSitterLights.blend = BlendMode.ADD;
			sprSitterLights.alpha = 0.5;
			sprSitterLights.render(new Point(x, y), FP.camera);
			Draw.resetTarget();
		}
		
	}

}