package source.Objects 
{
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.FP;
	import source.Solids.Slope;
	/**
	 * ...
	 * @author Time
	 */
	public class Worm extends Enemy
	{
		[Embed(source = "../../assets/graphics/worm.png")] private var imgWorm:Class;
		private var sprWorm:Spritemap = new Spritemap(imgWorm, 32, 26, endAnim);
		
		public function Worm(_x:int, _y:int) 
		{
			super(_x + 16, _y + 16);
			type = "Worm";
			graphic = sprWorm;
			
			sprWorm.add("Walk", [0, 1, 2, 1], 0.2);
			sprWorm.add("Hurt", [3, 0, 3, 0, 3], 0.3);
			sprWorm.play("Walk");
			sprWorm.centerOO();
			
			setHitbox(8, 22, 4, 10);
			
			mMaxspeed.x = 1;
			speed.x = mMaxspeed.x;
		}
		
		override public function update():void
		{
			super.update();
			var c:Entity = collide("Solid", x + 2 * FP.sign(speed.x), y);
			var cD:Entity = collide("Solid", x + 2 * FP.sign(speed.x), y + 6);
			if (!hit && ((c && !(c is Slope)) || !cD))
			{
				speed.x = -speed.x;
			}
			if (speed.x != 0)
			{
				sprWorm.scaleX = Math.abs(sprWorm.scaleX) * FP.sign(speed.x);
			}
			else
			{
				speed.x = mMaxspeed.x * -FP.sign(sprWorm.scaleX);
			}
			gravity();
			motionx(this, speed.x);
			motiony(this, speed.y);
			
			if (y - height / 2 >= FP.height)
			{
				FP.world.remove(this);
			}
		}
		
	}

}