package source.Solids 
{
	import net.flashpunk.Entity;
	import flash.geom.Point;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.graphics.Text;
	import source.Game;
	import source.Global;
	/**
	 * ...
	 * @author Noel Berry
	 */
	public class Solid extends Entity
	{
		[Embed(source = "../../assets/graphics/grass.png")] private var imgGrass:Class;
		private var sprGrass:Spritemap = new Spritemap(imgGrass, 40, 40);
		
		private var grassPositions:Vector.<Point> = new Vector.<Point>();
		private var grassFrames:Vector.<int> = new Vector.<int>();
		
		private var t:int = 0;
		
		public function Solid(x:int,y:int,w:int = 32,h:int = 32,t:int=1) 
		{
			type = "Solid";
			setHitbox(w, h);
			
			this.x = x;
			this.y = y;
			
			this.t = t * 4;
			
			sprGrass.centerOrigin();
			setBoundaries(w, h);
			
			layer = -75;
		}
		
		public function setBoundaries(width:int, height:int):void
		{
			var c:Entity;
			grassPositions = new Vector.<Point>();
			grassFrames = new Vector.<int>();
			for (var i:int = 0; i < width; i+=32)
			{
				grassPositions.push(new Point(i - 4, -4));
				grassFrames.push(t);
			}
			for (i = 0; i < width; i+=32)
			{
				grassPositions.push(new Point(i - 4, height - 35));
					grassFrames.push(t+2);
			}
			for (var j:int = 0; j < height; j+=32)
			{
				grassPositions.push(new Point(-4, j));
					grassFrames.push(t+3);
			}
			for (j = 0; j < height; j+=32)
			{
				grassPositions.push(new Point(width - 35, j));
					grassFrames.push(t+1);
			}
		}
		
		override public function render():void
		{
			if (Game.cycleSolids)
			{
				x += Global.player.mMaxspeed.x;
				if (x > FP.width)
				{
					x -= FP.width * 2;
				}
			}
			for (var i:int = 0; i < grassPositions.length; i++)
			{
				sprGrass.frame = grassFrames[i];
				sprGrass.render(new Point(grassPositions[i].x + x, grassPositions[i].y + y), FP.camera);
			}
			
		}
		
	}

}